/*
 * See the files COPYING and README for copyright information and how to reach
 * the author.
 *
 *  $Id: burn.h,v 1.1 2006/07/02 15:28:26 lordjaxom Exp $
 */

#ifndef VDR_BURN_BURN_H
#define VDR_BURN_BURN_H

#include <string>
#include <vdr/plugin.h>
#include <vdr/i18n.h>

namespace vdr_burn
{

	class plugin: public cPlugin
	{
	public:
		plugin(void);
		virtual ~plugin();

		static const char* get_config_path(void) { return ConfigDirectory(PLUGIN_NAME); }

		virtual const char* Version(void) { return VERSION; }
		virtual const char* Description(void) { return tr(DESCRIPTION); }
		virtual const char* CommandLineHelp(void);
		virtual bool ProcessArgs(int argc, char *argv[]);
		virtual bool Start(void);
		virtual void Stop(void);
#ifndef APIVERSION
		virtual bool Active(void);
#else
		virtual cString Active(void);
#endif
		virtual const char *MainMenuEntry(void);
		virtual cOsdObject *MainMenuAction(void);
		virtual cMenuSetupPage *SetupMenu(void);
		virtual bool SetupParse(const char *Name, const char *Value);

	private:
		static const char* VERSION;
		static const char* DESCRIPTION;
		static const char* MAINMENUENTRY;

		std::string m_mainMenuEntry;
	};

}

#endif // VDR_BURN_BURN_H
