/*
 * See the files COPYING and README for copyright information and how to reach 
 * the author.
 *
 *  $Id: logger-vdr.h,v 1.2 2006/06/12 18:13:46 lordjaxom Exp $
 */

#include "proctools/logger.h"
#include "proctools/startable.h"
#include <fstream>
 
namespace vdr_burn
{

	class logger_vdr: public proctools::logger, 
					  public proctools::startable<logger_vdr>
	{
		friend class proctools::startable<logger_vdr>;

	public:
		static void set_logfile(const std::string& filename);
		static void close_logfile(void);
	
	protected:
		logger_vdr(void) {}

		virtual void log(loglevel level, const std::string& message);

	private:
		static std::ofstream m_logfile;
	};
}
