#ifndef VGS_PROCTOOLS_RESULT_H
#define VGS_PROCTOOLS_RESULT_H

#include <string>

namespace proctools 
{

	template<typename Type, typename CharT = char>
	class result
	{
		typedef std::basic_string<CharT> string;

	public:
		result(const Type& value): m_value( value ) {}
		result(const Type& value, const string& error): 
				m_value( value ), m_error( error ) {}

		operator const Type&() const { return m_value; }
		operator const CharT*() const { return m_error.c_str(); }

	private:
		Type m_value;
		string m_error;
	};
}

#endif // VGS_PROCTOOLS_RESULT_H
