/*
 * See the files COPYING and README for copyright information and how to reach
 * the author.
 *
 *  $Id: setup.h,v 1.16 2006/07/01 21:10:13 lordjaxom Exp $
 */

#ifndef VDR_BURN_SETUP_H
#define VDR_BURN_SETUP_H

#include "common.h"
#include "proctools/property.h"
#include <string>
#include <vdr/menuitems.h>

namespace vdr_burn
{

// --- cBurnParameters --------------------------------------------------------

struct cBurnParameters
{
	cBurnParameters(void);

	bool ProcessArgs(int argc, char **argv);

	std::string DataPath;
	std::string TempPath;
	std::string DvdDevice;
	std::string IsoPath;
};

extern cBurnParameters BurnParameters;

// --- cBurnSetup -------------------------------------------------------------

class cBurnMenuSetupPage;

class setup: public proctools::property_bag
{
public:
	static setup& get(void);

	proctools::property<int> UseIso2UTF;
	proctools::property<int> RemovePath;
	proctools::property<int> OfferChapters;
	proctools::property<int> OfferDiskSize;
	proctools::property<int> OfferStoreMode;
	proctools::property<int> OfferDmhArchiveMode;
	proctools::property<int> DiskType;
	proctools::property<int> SkinIndex;
	proctools::property<int> ChaptersMode;
	proctools::property<int> StoreMode;
	proctools::property<int> DmhArchiveMode;
	proctools::property<int> DiskSize;
	proctools::property<int> CustomDiskSize;
	proctools::property<int> BurnSpeed;
	proctools::property<int> DemuxType;
	proctools::property<int> CutOnDemux;
	proctools::property<int> OfferCutOnDemux;
	proctools::property<int> RequantType;
	proctools::property<int> PreserveLogFiles;
	proctools::property<int> DefaultLanguage;
	proctools::property<int> MainMenuStatus;

private:
	friend class cBurnMenuSetupPage;

	setup(void);
};

// --- cBurnMenuSetupPage -----------------------------------------------------

class cBurnMenuSetupPage: public cMenuSetupPage
{
	friend struct setup_storer;

private:
	setup m_data;

protected:
	virtual void Store(void);

public:
	cBurnMenuSetupPage(void);
};

}

#endif // VDR_BURN_SETUP_H
